//
// myplay.cc
//
//  Takes the following orders to splay's mpeg lib
//   play mpegpath
//    pause
//    unpause
//    stop
//   quit
//
//  rev 1 jjw - 08/21/1999
//


#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#define PTHREADEDMPEG 1
#define HAVE_PTHREAD_H 1

#include "mpegsound.h"

void play (Rawplayer *, const char *);

main ()
{
    Rawplayer  * player;
    char         buffer [128];
    

    fprintf (stderr, "blah blah\n\n");
    player = new Rawplayer;
    player->initialize ("/dev/dsp");
    
    while (1) {
	gets (buffer);
	
	if (strncmp (buffer, "play ", 5) == 0) {
	    printf ("ok\n"); fflush (stdout);
	    play (player, buffer + 5);
	}

	else if (strcmp (buffer, "quit") == 0) {
	    printf ("ok\n"); fflush (stdout);
	    break;
	}

	else
	    printf ("what?!\n");
    }

    delete player;
}


void play (Rawplayer * player, const char * filename)
{
    char    buffer [128];
    bool    paused = false;
    int     flag = 1, err;
    fd_set  set;

    struct timeval tv;

    Soundinputstream  * loader;
    Mpegtoraw         * server;


    loader = Soundinputstream::hopen ((char *) filename, &err);

    server = new Mpegtoraw (loader, player);
    server->initialize ((char *) filename);

    server->makethreadedplayer (100);
    server->run (-1);

    while (flag) {
	if (! paused)
	    flag = server->run (5);
	
	FD_ZERO(&set);
	FD_SET(0, &set);
	tv.tv_sec = tv.tv_usec = 0;
	
	if (select (1, &set, 0, 0, &tv)) {
	    gets (buffer);
	    
	    if (strcmp (buffer, "pause") == 0) {
		printf ("ok\n"); fflush (stdout);
		server->pausethreadedplayer ();
		paused = true;
	    }
	    else if (strcmp (buffer, "unpause") == 0) {
		printf ("ok\n"); fflush (stdout);
		server->unpausethreadedplayer ();
		paused = false;
	    }
	    else if (strcmp (buffer, "stop") == 0) {
		printf ("ok\n"); fflush (stdout);
		server->stopthreadedplayer ();
		server->freethreadedplayer ();
		
		delete server;
		delete loader;
		break;
	    }
	    else if (strcmp (buffer, "stat") == 0) {
		printf ("%i/%i\n", server->getcurrentframe (),
			server->gettotalframe ()); fflush (stdout);
	    }
	    else
		printf ("what?!\n");
	}
    }
}
