//
// playerlib.cc
//
//  Makes Anders' program work.  Cause it doesn't otherwise.
//
//  rev 2 jjw - 10/01/1999
//


#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#define PTHREADEDMPEG 1
#define HAVE_PTHREAD_H 1

#include "mpegsound.h"
#include "playerlib.hh"


playerlib::playerlib ()
{
    player = new Rawplayer;
    player->initialize ("/dev/dsp");
}


playerlib::~playerlib ()
{
    delete player;
}


void playerlib::set_file (const char * filename)
{
    int err;


    loader = Soundinputstream::hopen ((char *) filename, &err);

    server = new Mpegtoraw (loader, player);
    server->initialize ((char *) filename);

    server->makethreadedplayer (100);
    server->run (-1);
}    


void playerlib::unset_file ()
{
    server->freethreadedplayer ();
		
    delete server;
    delete loader;
}


int playerlib::run ()
{
    return (server->run (5));
}


void playerlib::pause ()
{
    server->pausethreadedplayer ();
}


void playerlib::unpause ()
{
    server->unpausethreadedplayer ();
}


void playerlib::stop ()
{
    server->stopthreadedplayer ();
}


int playerlib::current_frame ()
{
    return (server->getcurrentframe ());
}


int playerlib::total_frames ()
{
    return (server->gettotalframe ());
}
